using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.IO;

namespace EG00750
{
    public partial class Form1 : Form
    {
        bool No_data = false;

        public Form1()
        {
            InitializeComponent();
            list_comport();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }


        

        private void Form1_Load(object sender, EventArgs e)
        {
         
         serialPort1.BaudRate = 19200;
         serialPort1.DataBits = 8;
         serialPort1.Parity = (Parity)Enum.Parse(typeof(Parity), "None");
         serialPort1.StopBits = (StopBits)Enum.Parse(typeof(StopBits), "One");
         serialPort1.ReadBufferSize = 32;
        }


        private void list_comport()
        {
            
            // Get a list of serial port names. 
            string[] ports = SerialPort.GetPortNames();

            
            // Display each port name to the console. 
            foreach (string port in ports)
            {

                cOMToolStripMenuItem.DropDownItems.Add(port, null, new EventHandler(port_Click));
            }
        }

        private void port_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.Close();

            string Port = sender.ToString();

            serialPort1.PortName = Port;
            serialPort1.Open();
            toolStripStatusLabel_com.Text = Port;

        }


        private void Form1_Leave(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.Close();
            if (Outfilectr > 0)
                Outfile.Close();

        }


        byte[] sbuffer = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ,0,0};
        byte sindex;

        private void decode_info()
        {

            this.textBox1.Text = sbuffer[3].ToString() + "." +sbuffer[2].ToString();
        
        }


        private void decode_string()
        {
            UInt16 tmp;
            CheckForIllegalCrossThreadCalls = false;
            tmp = 256;                                   // channel ref
            tmp *= (UInt16)sbuffer[23];
            tmp += (UInt16)sbuffer[22];
            tmp += (UInt16)(((sbuffer[3] & 0x10) == 0x10) ? 0x80 : 0x00);
            if (tmp == 32767)
                this.label10.Text = "-----";
            else if (tmp == 0x0001)
                this.label10.Text = "+++++";
            else if (tmp == 0x0002)
                this.label10.Text = "P";
            else
                this.label10.Text = (tmp / 100).ToString("D2") + "," + (tmp % 100).ToString("D2");

            tmp = 256;                                  // channel 1
            tmp *= (UInt16)sbuffer[5];
            tmp += (UInt16)sbuffer[4];
            tmp += (UInt16)(((sbuffer[2] & 0x01) == 0x01) ? 0x80 : 0x00);
            if (tmp == 32767)
                this.label1.Text = "-----";
            else if (tmp == 0x0001)
                this.label1.Text = "+++++";
            else if (tmp == 0x0002)
                this.label1.Text = "P";
            else
                this.label1.Text = (tmp / 100).ToString("D2") + "," + (tmp % 100).ToString("D2");
            
            tmp = 256;                                  // channel 2
            tmp *= (UInt16)sbuffer[7];
            tmp += (UInt16)sbuffer[6];
            tmp += (UInt16)(((sbuffer[2] & 0x02) == 0x02) ? 0x80 : 0x00);
            if (tmp == 32767)
                this.label2.Text = "-----";
            else if (tmp == 0x0001)
                this.label2.Text = "+++++";
            else if (tmp == 0x0002)
                this.label2.Text = "P";
            else
                this.label2.Text = (tmp / 100).ToString("D2") + "," + (tmp % 100).ToString("D2");

            tmp = 256;                                  // channel 3
            tmp *= (UInt16)sbuffer[9];
            tmp += (UInt16)sbuffer[8];
            tmp += (UInt16)(((sbuffer[2] & 0x04) == 0x04) ? 0x80 : 0x00);
            if (tmp == 32767)
                this.label3.Text = "-----";
            else if (tmp == 0x0001)
                this.label3.Text = "+++++";
            else if (tmp == 0x0002)
                this.label3.Text = "P";
            else
                this.label3.Text = (tmp / 100).ToString("D2") + "," + (tmp % 100).ToString("D2");

            tmp = 256;                                  // channel 4
            tmp *= (UInt16)sbuffer[11];
            tmp += (UInt16)sbuffer[10];
            tmp += (UInt16)(((sbuffer[2] & 0x08) == 0x08) ? 0x80 : 0x00);
            if (tmp == 32767)
                this.label4.Text = "-----";
            else if (tmp == 0x0001)
                this.label4.Text = "+++++";
            else if (tmp == 0x0002)
                this.label4.Text = "P";
            else
                this.label4.Text = (tmp / 100).ToString("D2") + "," + (tmp % 100).ToString("D2");

            tmp = 256;                                  // channel 5
            tmp *= (UInt16)sbuffer[13];
            tmp += (UInt16)sbuffer[12];
            tmp += (UInt16)(((sbuffer[2] & 0x10) == 0x10) ? 0x80 : 0x00);
            if (tmp == 32767)
                this.label5.Text = "-----";
            else if (tmp == 0x0001)
                this.label5.Text = "+++++";
            else if (tmp == 0x0002)
                this.label5.Text = "P";
            else
                this.label5.Text = (tmp / 100).ToString("D2") + "," + (tmp % 100).ToString("D2");

            tmp = 256;                                  // channel 6
            tmp *= (UInt16)sbuffer[15];
            tmp += (UInt16)sbuffer[14];
            tmp += (UInt16)(((sbuffer[3] & 0x01) == 0x01) ? 0x80 : 0x00);
            if (tmp == 32767)
                this.label6.Text = "-----";
            else if (tmp == 0x0001)
                this.label6.Text = "+++++";
            else if (tmp == 0x0002)
                this.label6.Text = "P";
            else
                this.label6.Text = (tmp / 100).ToString("D2") + "," + (tmp % 100).ToString("D2");

            tmp = 256;                                  // channel 7
            tmp *= (UInt16)sbuffer[17];
            tmp += (UInt16)sbuffer[16];
            tmp += (UInt16)(((sbuffer[3] & 0x02) == 0x02) ? 0x80 : 0x00);
            if (tmp == 32767)
                this.label7.Text = "-----";
            else if (tmp == 0x0001)
                this.label7.Text = "+++++";
            else if (tmp == 0x0002)
                this.label7.Text = "P";
            else
                this.label7.Text = (tmp / 100).ToString("D2") + "," + (tmp % 100).ToString("D2");

            tmp = 256;                                  // channel 8
            tmp *= (UInt16)sbuffer[19];
            tmp += (UInt16)sbuffer[18];
            tmp += (UInt16)(((sbuffer[3] & 0x04) == 0x04) ? 0x80 : 0x00);
            if (tmp == 32767)
                this.label8.Text = "-----";
            else if (tmp == 0x0001)
                this.label8.Text = "+++++";
            else if (tmp == 0x0002)
                this.label8.Text = "P";
            else
                this.label8.Text = (tmp / 100).ToString("D2") + "," + (tmp % 100).ToString("D2");

            tmp = 256;                                  // channel 9
            tmp *= (UInt16)sbuffer[21];
            tmp += (UInt16)sbuffer[20];
            tmp += (UInt16)(((sbuffer[3] & 0x08) == 0x08) ? 0x80 : 0x00);
            if (tmp == 32767)
                this.label9.Text = "-----";
            else if (tmp == 0x0001)
                this.label9.Text = "+++++";
            else if (tmp == 0x0002)
                this.label9.Text = "P";
            else
                this.label9.Text = (tmp / 100).ToString("D2") + "," + (tmp % 100).ToString("D2");

            if (Outfilectr > 0)
            {

                if ((Outfilectr % 10) == 1)
                {
                    Outfile.Write(this.label1.Text);
                    Outfile.Write("   ");
                    Outfile.Write(this.label2.Text);
                    Outfile.Write("   ");
                    Outfile.Write(this.label3.Text);
                    Outfile.Write("   ");
                    Outfile.Write(this.label4.Text);
                    Outfile.Write("   ");
                    Outfile.Write(this.label5.Text);
                    Outfile.Write("   ");
                    Outfile.Write(this.label6.Text);
                    Outfile.Write("   ");
                    Outfile.Write(this.label7.Text);
                    Outfile.Write("   ");
                    Outfile.Write(this.label8.Text);
                    Outfile.Write("   ");
                    Outfile.Write(this.label9.Text);
                    Outfile.Write("   ");
                    Outfile.Write(this.label10.Text);
                    Outfile.Write("   ");
                    Outfile.WriteLine(Outfilectr);
                }
                Outfilectr++;
            }
        }

        private bool do_chksum()
        {
            UInt16 chksum = 0;
            UInt16 i;
            UInt16 cmpval = 0;

            for(i=0;i<24;i++)
                chksum += sbuffer[i];
            chksum &= 0x7F7F;


            cmpval = 256;
            cmpval *= sbuffer[25];
            cmpval += sbuffer[24];

            return (chksum == cmpval)?true:false;
        }

        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            UInt16 i;
            byte chr;
            int temp=0;
            if (serialPort1.IsOpen)
             temp = serialPort1.BytesToRead;

            for (i = 0; i < temp; i++)
            {
                if (sindex == 26)
                {
                    if (do_chksum())
                    {
                        No_data = false;
                        switch (sbuffer[1])
                        {
                            case 0x04:
                                decode_string();                  // we read one data line
                                textBox2.Text = "ok";
                                break;
                            case 0x03:
                                decode_info();
                                break;
                            case 0x02:
                                textBox2.Text = "No Calibration!";
                                break;
                        }
                    }
                }
                
                chr = 0;
            if (serialPort1.IsOpen)
             chr = (byte)serialPort1.ReadByte();

             if ((chr & 0x80) == 0x80)
               {
                sbuffer[0] = chr;
                sindex = 1;
               }
            else
               {
                sbuffer[sindex] = chr;
                sindex++;
                if (sindex >= 29)
                    sindex = 29;

               }
            }

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (No_data == true)
            {
                this.label1.Text = "     ";
                this.label2.Text = "     ";
                this.label3.Text = "     ";
                this.label4.Text = "     ";
                this.label5.Text = "     ";
                this.label6.Text = "     ";
                this.label7.Text = "     ";
                this.label8.Text = "     ";
                this.label9.Text = "     ";
                this.label10.Text = "     ";
            }
            No_data = true;        // has to be reset till next tick
            toolStripStatusLabel2.Text = DateTime.Now.ToLongTimeString();
        }

        StreamWriter Outfile;
        int  Outfilectr = 0;

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            dialog.Title = "Select a file";
            //dialog.ShowDialog();
            

            if (dialog.ShowDialog() == DialogResult.OK)
            {
                Outfile = new StreamWriter(dialog.FileName);
                Outfilectr = 1;
                Outfile.WriteLine("EG00750");
                Outfile.WriteLine("CH1     CH2     CH3     CH4     CH5     CH6     CH7     CH8     CH9     REF");
                toolStripStatusLabel1.Text = dialog.FileName;
            }
        }

       

    }
}